/*
 * Argument parsing and conversion functions for convenience
 */

#include "Object.h"
#include "error.h"
#include "expr.h"


/*
 * Reads an expression and converts it to an integer.
 * Generates an error if the result is a string.
 */
int int_expression()
{
  Object val;

  expression(&val);
  if(val.isString())
    error(6, "Type mismatch: number needed");

  return val.toInt();
}


/*
 * Reads an expression and converts it to an integer.
 * Generates an error if the result is a string.
 */
int int_factor()
{
  Object val;

  factor(&val);
  if(val.isString())
    error(6, "Type mismatch: number needed");

  return val.toInt();
}


/*
 * Reads an expression and converts it to an integer.
 * Generates an error if the result is a string.
 */
float float_expression()
{
  Object val;

  expression(&val);
  if(val.isString())
    error(6, "Type mismatch: number needed");

  return val.toFloat();
}


/*
 * Reads an expression and converts it to an integer.
 * Generates an error if the result is a string.
 */
float float_factor()
{
  Object val;

  factor(&val);
  if(val.isString())
    error(6, "Type mismatch: number needed");

  return val.toFloat();
}


char *string_expression()
{
  Object val;

  expression(&val);
  if(!val.isString())
    error(6, "Type mismatch: string needed");

  return val.stringValue;
}


char *string_factor()
{
  Object val;

  factor(&val);
  if(!val.isString())
    error(6, "Type mismatch: string needed");

  return val.stringValue;
}

