
#include <stdio.h>
#include <string.h>  // strdup

#include "Object.h"
#include "arg.h"
#include "expr.h"
#include "lex.h"  // nextToken()
#include "token.h"


void exec_get(Object *res)
{
  int c = getchar();
  res->setInt(c);
}


void exec_getString(Object *res)
{
  char buf[2];

  buf[0] = (char) getchar();  // check for EOF
  buf[1] = '\0';

  res->setString(strdup(buf));
}


// INKEY, INKEY$: system dependent




/*
 * PRINT statement
 */
void exec_print()
{
  Object val;
  bool right = true;  // right-justify?
  bool hex = false;   // hexadecimal mode?

  nextToken();  // skip PRINT
  while(ttype != TT_EOL && ttype != ':') {
    switch(ttype) {
    case ';':
      right = false;
      hex = false;
      nextToken();
      break;
    case ',':
      right = true;
      hex = false;
      nextToken();
      break;
    case '~':
      hex = true;
      nextToken();
      break;
    case '\'':
      putchar('\n');
      nextToken();
      break;
    case TT_SPC:
      nextToken();
      int n;
      n = int_factor();
      for(int i = 0; i < n; i++)
	putchar(' ');
      break;
    default:
      expression(&val);
      if(val.isInteger())
	printf("%d", val.intValue);
      else if(val.isFloat())
	printf("%f", val.floatValue);
      else if(val.isString())
	printf("%s", val.stringValue);
    }
  }
  putchar('\n');  // except last token was ';'
}

