/*
 *  These functions and global variables are important for normal keyword
 *  handlers.
 */


#include "token.h"
#include "Object.h"


// lex.h:

// the current token type
extern int ttype;

// string value of current token
extern char sval[];

// float value of current token
extern float nval;

void nextToken();


// arg.h:

int int_expression();
int int_factor();
float float_expression();
float float_factor();
char *string_expression();
char *string_factor();


// expr.h:

void expression(Object *val);
void factor(Object *val);


void error(int code, const char *msg, ...);

void expect(int token, int code, const char *msg);
void expect(int token);


// for things like INPUT, READ, SWAP, ...:

void getVariable(const char *name, Object *val);
void assign(Object *dest, Object *val);
void assign(const char *name, Object *val);
